<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class ChecklistAgendFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->alias = "checklist";
    }

    public function listTask($param,$params) {
        $sql = "SELECT FCM_CHECKLISTAGEND.DTHORAAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, FCM_CHECKLISTAGEND.DTHRFINALAGEND,
                FCM_LOCALCLI.DSCORIDLOCAL, MAX(FCM_ATIVIDADE.DSCORIDATIVIDADE) AS CORATIVIDADE
                        FROM FCM_CHECKLISTAGEND
                        JOIN FCM_LOCALCLI
                          ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_CHECKLISTAGEND.NRLOCALCLIENTE
                        JOIN FCM_ATIVIDADECHK
                          ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST
                        JOIN FCM_ATIVIDADE
                          ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                 WHERE TRUNC(FCM_CHECKLISTAGEND.DTHORAAGEND) BETWEEN TO_DATE( :startPeriod, 'YYYY-MM-DD') AND TO_DATE( :finishPeriod, 'YYYY-MM-DD')
                         AND FCM_CHECKLISTAGEND.NRFUNCIONARIO = :nr ".$params."
                    GROUP BY FCM_CHECKLISTAGEND.DTHORAAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, FCM_CHECKLISTAGEND.DTHRFINALAGEND, FCM_LOCALCLI.DSCORIDLOCAL
                    ORDER BY DTHORAAGEND";

        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function infoTask($param) {
        $sql = "SELECT FCM_LOCALCLI.NMLOCALCLIENTE, FCM_TIPOLOCALCLI.NMTIPOLOCALCLI, FCM_FUNCIONARIO.NMFUNCIONARIO, FCM_CHECKLISTAGEND.DTHORAAGEND,
                  FCM_CHECKLISTAGEND.DTHRFINALAGEND
                 FROM FCM_CHECKLISTAGEND
                 JOIN FCM_LOCALCLI
                   ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_CHECKLISTAGEND.NRLOCALCLIENTE
                 JOIN FCM_TIPOLOCALCLI
                   ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                 JOIN FCM_FUNCIONARIO
                   ON FCM_CHECKLISTAGEND.NRFUNCIONARIO = FCM_FUNCIONARIO.NRFUNCIONARIO
                WHERE TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'YYYY-MM-DD HH24:MI:SS') >= :startPeriod
                  AND TO_CHAR(FCM_CHECKLISTAGEND.DTHRFINALAGEND, 'YYYY-MM-DD HH24:MI:SS') <= :finishPeriod
                  AND FCM_CHECKLISTAGEND.NMCHECKLISTAGEND = :nome
                  AND FCM_CHECKLISTAGEND.NRFUNCIONARIO = :nr
             ORDER BY DTHORAAGEND";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function taskOfTheEmployee($param,$periodoGer,$periodoCheck) {
        $sql = "SELECT ('V-' || FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK) as NRCHECKLISTAGEND,
                       ('Vistoria-' || FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK) as NMCHECKLISTAGEND, FCM_LOCALCLI.NMLOCALCLIENTE as NMLOCALCLIENTE,
                       FCM_GERENCIAMENTOCHK.DTHORAAGEND as DTHORAAGEND
                  FROM FCM_GERENCIAMENTOCHK
                  JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_GERENCIAMENTOCHK.NRLOCALCLIENTE
                WHERE FCM_GERENCIAMENTOCHK.NRFUNCIONARIO = :nr
                {$periodoGer}

                UNION

                SELECT TO_CHAR(FCM_CHECKLISTAGEND.NRCHECKLISTAGEND) as NRCHECKLISTAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND as NMCHECKLISTAGEND,
                FCM_LOCALCLI.NMLOCALCLIENTE as NMLOCALCLIENTE, FCM_CHECKLISTAGEND.DTHORAAGEND as DTHORAAGEND
                  FROM FCM_CHECKLISTAGEND
                  JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = FCM_CHECKLISTAGEND.NRLOCALCLIENTE
                WHERE FCM_CHECKLISTAGEND.NRFUNCIONARIO = :nr
                {$periodoCheck}
              ORDER BY DTHORAAGEND";

        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function transferTask($param) {
      $sql = "UPDATE FCM_CHECKLISTAGEND
                 SET NRFUNCIONARIO = ".$param['nr']."
               WHERE NRCHECKLISTAGEND IN (".$param['list'].")";

      $std = $this->connection->prepare($sql);
      $std->execute();
  }

  public function dadosTask($param) {
    $sql = "SELECT NRCHECKLISTAGEND, NRFUNCIONARIO, DTHORAAGEND
              FROM FCM_CHECKLISTAGEND
             WHERE NRCHECKLISTAGEND = ".$param;

    $std = $this->connection->prepare($sql);
    $std->execute();
    return $std->fetchAll();
  }

  public function getLocals($id) {

      $sql = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE,
                           FCM_LOCALCLI.NRSETOR, FCM_LOCALCLI.NRLOCALCLIENTEPAI, FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                     FROM FCM_LOCALCLI
                     JOIN FCM_TIPOLOCALCLI
                       ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
                        WHERE FCM_TIPOLOCALCLI.IDTIPOLOCALCLI = :ID";


      $std = $this->connection->prepare($sql);

      $std->execute($id);
      return $std->fetchAll();
    }
    
    public function listChecklistAgend($params) {
        $useParams = false;
        $sqlCode = "SELECT checklist.NRCHECKLISTAGEND, checklist.NRLOCALCLIENTE,
            checklist.NRFUNCIONARIO, checklist.IDSITUACAOAGEND, checklist.DTHORAAGEND,
            checklist.IDATIVO, checklist.NRORG, checklist.DTINCLUSAO,
            checklist.CDOPERINCLUSAO, checklist.NRORGINCLUSAO, checklist.DTULTATU,
            checklist.CDOPERULTATU, checklist.NRORGULTATU, checklist.NMCHECKLISTAGEND,
            checklist.DSJUSTCANCELAMENTO FROM FCM_CHECKLISTAGEND checklist";
        $whereClausule =  $this->concatWhereClausule($params);
        if (strlen($whereClausule) > 0) {
            $useParams = true;
            $sqlCode .= $whereClausule;
        }
        $std = $this->connection->prepare($sqlCode);
        if ($useParams) {
            $std->execute($params);   
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }
    
    private function concatWhereClausule($params) {
        $useParams = false;
        $paramKeys = array_keys($params);
        $query = "";
        foreach($paramKeys as $key) {
            if (!$useParams) {
                $useParams = true;
                $query.= " WHERE ";
            } else {
                $query.= " AND ";
            }
            $query.= $this->alias . "." . $key . " = :" . $key;
        }
        return $query;
    }
    
    
    public function checklistAgendsInnerJoinChecklist($params) {
        $useParams = false;
        $sqlCode = "SELECT checklist.NRCHECKLISTAGEND, checklist.NRLOCALCLIENTE,
            checklist.NRCHECKLIST,
            checklist.NRFUNCIONARIO, checklist.IDSITUACAOAGEND, checklist.DTHORAAGEND,
            checklist.IDATIVO, checklist.NRORG, checklist.DTINCLUSAO,
            checklist.CDOPERINCLUSAO, checklist.NRORGINCLUSAO, checklist.DTULTATU,
            checklist.CDOPERULTATU, checklist.NRORGULTATU, checklist.NMCHECKLISTAGEND,
            checklist.DSJUSTCANCELAMENTO, chklist.NRSETOR, local.DSCORIDLOCAL,
            checklist.DTHRFINALAGEND, chklist.DSCHECKLIST, atv.DSCORIDATIVIDADE
            FROM FCM_CHECKLISTAGEND checklist
            INNER JOIN FCM_CHECKLIST chklist
            ON checklist.NRCHECKLIST = chklist.NRCHECKLIST
            INNER JOIN FCM_LOCALCLI local
            ON local.NRLOCALCLIENTE = checklist.NRLOCALCLIENTE
            INNER JOIN FCM_ATIVIDADECHK atvchk
            ON atvchk.NRCHECKLIST = chklist.NRCHECKLIST
            INNER JOIN FCM_ATIVIDADE atv
            ON atv.NRATIVIDADE = atvchk.NRATIVIDADE";
        $paramKeys = array_keys($params);
        $query = "";
        $paramCount = 0;
        $useAnd = false;
        foreach($paramKeys as $key) {
            $alias = "";
            if ($useAnd) {
                $query.= " AND ";
            } else {
                $query .= " WHERE ";
                $useAnd = true;
            }
            // os ifs a seguir servem para definir o apelido da tabela
            // a qual vai ser usada para comparar o atributo passado
            if ($key == "NRCHECKLIST") {
                $alias = "chklist";
            } else if($key == "NRTIPOLOCALCLI" || $key == "NRSETOR") {
                $alias = "local";
            } else {
                $alias = "checklist";
            }
            
            if (is_array($params[$key])) {
                $query .= $alias . "." . $key . " IN (";
                $lenParams = count($params[$key]);
                for ($i = 0; $i < $lenParams; $i++) {
                    $query .= $params[$key][$i];
                    if ($i !== $lenParams - 1) {
                        $query .= ", ";
                    }
                }
                $query .= ") ";
                unset($params[$key]);
            } else {
                $query .= $alias . "." . $key . " = :" . $key;
                $paramCount++;
            }
        }
        $sqlCode .= $query;
        $std = $this->connection->prepare($sqlCode);
        if ($paramCount > 0) {
            $std->execute($params);   
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }
    
    public function updateChecklistAgend($params) {
        $idEntity = $params["NRCHECKLISTAGEND"];
        unset($params["NRCHECKLISTAGEND"]);
        $sql = "UPDATE FCM_CHECKLISTAGEND
        SET ";
        $query = $this->concatUpdate($params);
        $sql .= $query . " WHERE NRCHECKLISTAGEND = " . $idEntity;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $params;
    }
    
    protected function concatUpdate($params) {
        $paramKeys = array_keys($params);
        $query = "";
        for ($i = 0; $i < count($paramKeys); $i++) {
            $query .= $paramKeys[$i] . " = :" . $paramKeys[$i];
            if ($i != count($paramKeys) - 1) {
                $query .= ", ";
            }
        }
        return $query;
    }
}

?>