<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class EscopoManutFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function escopo() {
      $sql = "SELECT NRESCOPOMANUT, NMESCOPOMANUT
                FROM FCM_ESCOPOMANUT";
      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
    
    public function inserirEscopo($parametros) {

        $sql = "INSERT INTO FCM_ESCOPOMANUT(NRESCOPOMANUT, NMESCOPOMANUT, NRORG, DTINCLUSAO)
                    VALUES(:NRESCOPOMANUT, :NMESCOPOMANUT, :NRORG, SYSDATE)";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }

    public function getInformacoesEscopo() {

        $sql = "SELECT NRESCOPOMANUT, NMESCOPOMANUT
                    FROM FCM_ESCOPOMANUT";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function getEscopo($parametro) {

        $sql = "SELECT NRESCOPOMANUT, NMESCOPOMANUT
                    FROM FCM_ESCOPOMANUT
                    WHERE NRESCOPOMANUT = :NRESCOPOMANUT";

        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
        return $std->fetchAll();
    }

    public function deletarEscopo($parametro) {

        $sql = "DELETE FCM_ESCOPOMANUT
                    WHERE NRESCOPOMANUT = :NRESCOPOMANUT";

        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
    }

    public function updateEscopo($parametros) {

        $sql = "UPDATE FCM_ESCOPOMANUT
                    SET NMESCOPOMANUT = :NMESCOPOMANUT,
                        DTULTATU = SYSDATE
                  WHERE NRESCOPOMANUT = :NRESCOPOMANUT";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }
}

?>