<?php

namespace FM\Service;

use FM\Factory\ComentSolicitServFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class ComentSolicitServService {

    protected $ComentSolicitServFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct (ComentSolicitServFactory $ComentSolicitServFactory, Environment $Environment, NewCode $newCode, EntityManager $entityManager) {
        $this->ComentSolicitServFactory = $ComentSolicitServFactory;
        $this->connection = $entityManager->getConnection();
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }
    
    public function getComentarios($param){
        return $this->ComentSolicitServFactory->getComentarios($param);;
    }
    
    public function postComentarios($param){
        $this->connection->beginTransaction();
        
        try {
            $this->ComentSolicitServFactory->postComentarios(array(
            "NRCOMENTSOLICITSERV" => $this->newCode->getCodeByTableName("FCM_COMENTSOLICITSERV", 20, 1, 10, true),
            "NRSOLICITACAOSERV" => intval($param['NRSOLICITACAOSERV']),
            "NRFUNCCOMENTARIO" => intval($param['NRFUNCCOMENTARIO']),
            "DTCOMENTARIO" => $param['DTCOMENTARIO'],
            "DSCOMENTARIO" => $param['DSCOMENTARIO'],
            "NRORG" => 20 
        ));
            
            $this->connection->commit();
            $response = "OK";
        } catch(\Exception $e) {
            $this->connection->rollback();
            $response = ($e->getMessage());
        }
        return [$response];
    }
}

?>